﻿Imports Telerik.Windows.Controls
Imports System.Collections.ObjectModel
Imports Telerik.Windows.Controls.ScheduleView
Imports System.Globalization

Public Class ExampleViewModel
	Inherits ViewModelBase

	Private _appointmentsSource As Uri
	Private _appointments As ObservableCollection(Of Appointment)

	Public Property AppointmentsSource As Uri
		Get
			Return Me._appointmentsSource
		End Get
		Set(ByVal value As Uri)
			Me._appointmentsSource = value
		End Set
	End Property

	Public ReadOnly Property Appointments As ObservableCollection(Of Appointment)
		Get
			If (Me._appointments Is Nothing) Then
				Me._appointments = New ObservableCollection(Of Appointment)(LoadAppointmentsSource(Me.AppointmentsSource))
			End If
			Return Me._appointments
		End Get
	End Property

	Protected Shared Function LoadAppointmentsSource(ByVal _appointmentsSource As Uri) As IEnumerable(Of Appointment)
		If (Not _appointmentsSource Is Nothing) Then
			Dim _appointments As IEnumerable(Of Appointment) = TryCast(Application.LoadComponent(_appointmentsSource), IEnumerable(Of Appointment))

			Dim firstDate As DateTime = _appointments.Min(AddressOf ExampleViewModel.GetStart)

			Dim firstDay As DayOfWeek = CultureInfo.CurrentCulture.DateTimeFormat.FirstDayOfWeek
			Dim firstDayOfCurrentWeek As DateTime = DateTime.Today.Subtract(TimeSpan.FromDays(Convert.ToInt32(DateTime.Today.DayOfWeek) - Convert.ToInt32(firstDay)))

			Dim offset As TimeSpan = firstDayOfCurrentWeek - firstDate
			For Each _appointment As IAppointment In _appointments
				_appointment.Start += offset
				_appointment.End += offset

			Next
			Return _appointments

		End If
		Return Enumerable.Empty(Of Appointment)()
	End Function

	Private Shared Function GetStart(ByVal _a As Appointment) As DateTime
		Return _a.Start.Date
	End Function
End Class
