﻿Imports Telerik.Windows.Controls
Imports System.Globalization
Imports Telerik.Windows.Controls.ScheduleView

Public Class MyGamesViewDefinition
	Inherits CustomViewDefinition

	Shared Sub New()
		StretchGroupHeadersProperty.OverrideMetadata(GetType(MyGamesViewDefinition), New FrameworkPropertyMetadata(True))
		VisibleDaysProperty.OverrideMetadata(GetType(MyGamesViewDefinition), New FrameworkPropertyMetadata(7))
		LargeChangeIntervalProperty.OverrideMetadata(GetType(MyGamesViewDefinition), New FrameworkPropertyMetadata(DateTimeInterval.FromDays(7)))
	End Sub

	Protected Overrides Function FormatVisibleRangeText(ByVal formatInfo As System.IFormatProvider, ByVal rangeStart As System.DateTime, ByVal rangeEnd As System.DateTime, ByVal currentDate As System.DateTime) As String
		Dim format As String = If(rangeStart.Year = rangeEnd.Year, (If(rangeStart.Month = rangeEnd.Month, "{0:d } - {1:d MMMM yyyy}", "{0:d MMMM} - {1:d MMMM yyyy}")), "{0:d MMMM yyyy} - {1:d MMMM yyyy}")

		Return String.Format(formatInfo, format, rangeStart, rangeEnd)
	End Function

	Protected Overrides Function GetVisibleRangeStart(ByVal currentDate As DateTime, ByVal culture As CultureInfo, ByVal firstDayOfWeek As System.Nullable(Of DayOfWeek)) As DateTime
		If culture Is Nothing Then
			culture = CultureInfo.InvariantCulture
		End If

		Dim dayOfWeek As DayOfWeek = If(firstDayOfWeek, culture.DateTimeFormat.FirstDayOfWeek)

		Return CalendarHelper.GetFirstDayOfWeek(currentDate, dayOfWeek)
	End Function

	Protected Overrides Function GetVisibleRangeEnd(ByVal currentDate As DateTime, ByVal culture As CultureInfo, ByVal firstDayOfWeek As System.Nullable(Of DayOfWeek)) As DateTime
		If culture Is Nothing Then
			culture = CultureInfo.InvariantCulture
		End If

		Dim dayOfWeek As DayOfWeek = If(firstDayOfWeek, culture.DateTimeFormat.FirstDayOfWeek)
		If Me.DayEndTime > Me.DayStartTime Then
			Return CalendarHelper.GetFirstDayOfWeek(currentDate, dayOfWeek).AddDays(Me.VisibleDays - 1).Add(Me.DayEndTime)
		End If

		Return CalendarHelper.GetFirstDayOfWeek(currentDate, dayOfWeek).AddDays(Me.VisibleDays).Add(Me.DayEndTime)
	End Function

End Class
