﻿Imports Telerik.Windows.Controls
Imports Telerik.Windows.Controls.ScheduleView

Public Class ResourceDependentAppointmentStyleSelector
	Inherits OrientedAppointmentItemStyleSelector

	Private _othersGamesStyle As Style
	Private _singlePlayGamesStyle As Style

	Public Property OthersGamesStyle() As Style
		Get
			Return Me._othersGamesStyle
		End Get
		Set(ByVal value As Style)
			Me._othersGamesStyle = value
		End Set
	End Property

	Public Property MySinglePlayGamesStyle() As Style
		Get
			Return Me._singlePlayGamesStyle
		End Get
		Set(ByVal value As Style)
			Me._singlePlayGamesStyle = value
		End Set
	End Property

	Public Overrides Function SelectStyle(ByVal item As Object, ByVal container As DependencyObject, ByVal activeViewDefinition As ViewDefinitionBase) As Style
		Dim appointment As IAppointment = TryCast(item, IAppointment)
		If appointment Is Nothing Then
			Return MyBase.SelectStyle(item, container, activeViewDefinition)
		End If

		If Not OwnedByCurrentUser(appointment) Then
			Return Me.OthersGamesStyle
		Else
			Return Me.MySinglePlayGamesStyle
		End If
	End Function

	Private Shared Function OwnedByCurrentUser(ByVal appointment As IAppointment) As Boolean
		Return appointment.Resources.OfType(Of IResource)().Any(Function(r As IResource) r.ResourceType = "UserName" AndAlso r.ResourceName = User.CurrentUser)
	End Function

	Private Shared Function CoachGame(ByVal appointment As IAppointment) As Boolean
		Return appointment.Resources.OfType(Of IResource)().Any(Function(r As IResource) r.ResourceType = "Coach" AndAlso r.ResourceName = "Coach")
	End Function

End Class
