﻿using System;
using System.Windows;
using System.Windows.Data;
using Telerik.Windows.Controls;

namespace ScheduleView_CustomViewDefinition
{
	public class GroupHeaderStyleSelector : ScheduleViewStyleSelector
	{
		private Style dateGroupStyle;
		private Style courtGroupStyle;

		private Style carltonCourtStyle;
		private Style graceCourtStyle;

		private Style coachStyle;
		private Style singlePlayStyle;

		private Style userNameStyle;

		public Style DateGroupStyle
		{
			get
			{
				return this.dateGroupStyle;
			}
			set
			{
				this.dateGroupStyle = value;
			}
		}

		public Style CourtGroupStyle
		{
			get
			{
				return this.courtGroupStyle;
			}
			set
			{
				this.courtGroupStyle = value;
			}
		}

		public Style CarltonCourtStyle
		{
			get
			{
				return this.carltonCourtStyle;
			}
			set
			{
				this.carltonCourtStyle = value;
			}
		}

		public Style GraceCourtStyle
		{
			get
			{
				return this.graceCourtStyle;
			}
			set
			{
				this.graceCourtStyle = value;
			}
		}

		public Style CoachStyle
		{
			get
			{
				return this.coachStyle;
			}
			set
			{
				this.coachStyle = value;
			}
		}

		public Style SinglePlayStyle
		{
			get
			{
				return this.singlePlayStyle;
			}
			set
			{
				this.singlePlayStyle = value;
			}
		}

		public Style UserNameStyle
		{
			get
			{
				return this.userNameStyle;
			}
			set
			{
				this.userNameStyle = value;
			}
		}

		public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDeifinition)
		{
			CollectionViewGroup cvg = item as CollectionViewGroup;
			if (cvg != null)
			{
				object name = cvg.Name;
				if (name is DateTime)
				{
					return this.DateGroupStyle;
				}
				else if (name is Resource)
				{
					Resource r = name as Resource;
					switch (r.ResourceName)
					{
						case "Carlton Court": return this.CarltonCourtStyle;
						case "Grace Court": return this.GraceCourtStyle;

						case "Coach": return this.CoachStyle;
						case "Single Play": return this.SinglePlayStyle;

						default: break;
					}

					switch (r.ResourceType)
					{
						case "UserName": return this.UserNameStyle;

						default: break;
					}
				}
			}
			return base.SelectStyle(item, container, activeViewDeifinition);
		}
	}
}