﻿using System;
using Telerik.Windows.Controls;

namespace ScheduleView_CustomViewDefinition
{
	public class ViewModel : ExampleViewModel
	{
		private Func<object, bool> groupFilter;

		public ViewModel()
		{
			this.groupFilter = new Func<object, bool>(this.GroupFilterFunc);
		}

		public Func<object, bool> GroupFilter
		{
			get
			{
				return this.groupFilter;
			}
			private set
			{
				this.groupFilter = value;
				this.OnPropertyChanged(() => this.GroupFilter);
			}
		}

		private void UpdateGroupFilter()
		{
			this.GroupFilter = new Func<object, bool>(this.GroupFilterFunc);
		}

		private bool GroupFilterFunc(object groupName)
		{
			IResource resource = groupName as IResource;

			return resource == null ? true : resource.ResourceName == User.CurrentUser;
		}
	}
}